using Microsoft.Extensions.DependencyInjection;
using System.Drawing;
using Microsoft.Extensions.Logging;
using NLog.Extensions.Logging;
using Microsoft.Extensions.Configuration;
using Serilog;

namespace DoubleDeckerBus
{
    internal static class Program
    {
        [STAThread]
        static void Main()
        {
            // To customize application configuration such as set high DPI settings or default font,
            // see https://aka.ms/applicationconfiguration.
            ApplicationConfiguration.Initialize();
            var services = new ServiceCollection();
            ConfigureServices(services);
            using (ServiceProvider serviceProvider = services.BuildServiceProvider())
            {
                Application.Run(serviceProvider.GetRequiredService<FormBusCollection>());
            }
        }
        private static void ConfigureServices(ServiceCollection services)
        {
            services.AddSingleton<FormBusCollection>().AddLogging(option =>
            {
                string[] path = Directory.GetCurrentDirectory().Split('\\');
                string pathNeed = "";
                for (int i = 0; i < path.Length - 3; i++)
                {
                    pathNeed += path[i] + "\\";
                }
                var configuration = new ConfigurationBuilder().SetBasePath(Directory.GetCurrentDirectory())
                .AddJsonFile(path: $"appSettings.json", optional: false, reloadOnChange: true).Build();

                var logger = new LoggerConfiguration().ReadFrom.Configuration(configuration).CreateLogger();
                option.SetMinimumLevel(LogLevel.Information);
                option.AddSerilog(logger);
            });
        }
    }
}
